Chained-CI examples
===================

Role
----
Chained-CI is a way to run a set of projects, each one as a job in a top level
pipeline.

This project, running on gitlab CE, is triggering configured projects one
after the other, or in parallele, sharing configuration through artifacts. This
allow to integrate projects managed by third parties, or running together
independent projects.

___This project is hosting the pipelines and the pipeline configuration.
See https://gitlab.com/Orange-OpenSource/lfn/ci_cd/chained-ci-roles to see the
roles needed to run thoses pipelines___

In this project, an example of a chain named example1 with 3 stages is
implemented. In the first config stage, an artifact example1.zip stored in
chained-ci-examples project under repo-config/config/artifacts is loaded.  
This artifact is composed of 2 directories vars and inventory. The file infra
is included in inventory directory.  

The next stages are covered by the following git projects

* chained-ci-dummy1

  * The first job check the presence of infra file in the obtained config artifact
  * The second job creates a new file date under vars directory

* chained-ci-dummy2

  * The first job plays an ansible playbook to display the content of artifacts
  * The second job plays another ansible playbook that adds a yaml file results
  under vars directory

This example demonstrates the capacity of chained-ci to chain different git
projects and to exchange static and dynamic artifacts.  

Input
-----
  - Environment variables:
    - __Required__:
      - ANSIBLE_VAULT_PASSWORD:
        - role: read project triggers
        - example: abcdefghijklmnopqrstuvwxyz
      - POD:
        - role: pod name as defined in pod_inventory/inventory
        - example: example1
        - default: none
    - Optional:
      - AREYOUSURE:
        - role: disable the deployment protection on some pods
        - default: ''
        - values: '' or 'MAIS OUI !!!'
      - ansible_verbose:
          - role: verbose option for ansible
          - values: "", "-vvv"
          - default: ""
      - config_branch:
          - role: the branch for config
          - default: master
      - dummy_branch:
          - role: the branch for dummy project
          - default: master
      - dummy2_branch:
          - role: the branch for dummy2 project
          - default: master
Output
------
  - artifacts: each step can fetch the artifact generated by the sub-project as
      defined in the git_projects variable pull_artifacts
